HaskellForMaths-0.4.8: Combinatorics, group theory, commutative algebra, non-commutative algebra

Safe Haskell | Safe
Language | Haskell98

Math.QuantumAlgebra.TensorCategory

Description

A module defining classes and example instances of categories, monoidal categories and braided categories

# Documentation

class MCategory c where Source

Associated Types

data Ob c :: * Source

data Ar c :: * Source

Methods

id_ :: Ob c -> Ar c Source

source, target :: Ar c -> Ob c Source

(>>>) :: Ar c -> Ar c -> Ar c Source

Instances

MCategory Cob2 Source |
MCategory Braid Source |
MCategory FinCard Source |
MCategory FinOrd Source |
MCategory OrientedTangle Source |
MCategory Tangle Source |
Num k => MCategory (Vect k) Source |

class (MCategory a, MCategory b) => MFunctor a b where Source

Methods

fob :: Ob a -> Ob b Source

far :: Ar a -> Ar b Source

Instances

MFunctor Braid FinCard Source |
MFunctor FinOrd FinCard Source |

class MCategory c => Monoidal c where Source

Methods

tunit :: Ob c Source

tob :: Ob c -> Ob c -> Ob c Source

tar :: Ar c -> Ar c -> Ar c Source

Instances

Monoidal Cob2 Source |
Monoidal Braid Source |
Monoidal FinCard Source |
Monoidal FinOrd Source |
Monoidal OrientedTangle Source |
Monoidal Tangle Source |

class Monoidal c => StrictMonoidal c Source

class Monoidal c => WeakMonoidal c where Source

Methods

assoc :: Ob c -> Ob c -> Ob c -> Ar c Source

lunit :: Ob c -> Ar c Source

runit :: Ob c -> Ar c Source

class Monoidal c => Braided c where Source

Methods

twist :: Ob c -> Ob c -> Ar c Source

Instances

Braided Braid Source |

class Braided c => Symmetric c Source

data FinOrd Source

Instances

Monoidal FinOrd Source |
MCategory FinOrd Source |
MFunctor FinOrd FinCard Source |
Eq (Ob FinOrd) Source |
Eq (Ar FinOrd) Source |
Ord (Ob FinOrd) Source |
Ord (Ar FinOrd) Source |
Show (Ob FinOrd) Source |
Show (Ar FinOrd) Source |
data Ob FinOrd = FinOrdOb Int Source |
data Ar FinOrd = FinOrdAr Int Int [Int] Source |

finOrdAr :: Int -> Int -> [Int] -> Ar FinOrd Source

data FinCard Source

Instances

Monoidal FinCard Source |
MCategory FinCard Source |
MFunctor Braid FinCard Source |
MFunctor FinOrd FinCard Source |
Eq (Ob FinCard) Source |
Eq (Ar FinCard) Source |
Ord (Ob FinCard) Source |
Ord (Ar FinCard) Source |
Show (Ob FinCard) Source |
Show (Ar FinCard) Source |
data Ob FinCard = FinCardOb Int Source |
data Ar FinCard = FinCardAr Int Int [Int] Source |

finCardAr :: Int -> Int -> [Int] -> Ar FinCard Source

finPerm :: [Int] -> Ar FinCard Source

data Braid Source

Instances

Braided Braid Source |
Monoidal Braid Source |
MCategory Braid Source |
MFunctor Braid FinCard Source |
Eq (Ob Braid) Source |
Eq (Ar Braid) Source |
Ord (Ob Braid) Source |
Ord (Ar Braid) Source |
Show (Ob Braid) Source |
Show (Ar Braid) Source |
data Ob Braid = BraidOb Int Source |
data Ar Braid = BraidAr Int [Int] Source |

t :: Int -> Int -> Ar Braid Source

t' :: Int -> Int -> Ar Braid Source

data Vect k Source

Instances

Eq (Ob (Vect k)) Source |
Eq (Ar (Vect k)) Source |
Ord (Ob (Vect k)) Source |
Ord (Ar (Vect k)) Source |
Show (Ob (Vect k)) Source |
Show (Ar (Vect k)) Source |
Num k => MCategory (Vect k) Source |
data Ob (Vect k) = VectOb Int Source |
data Ar (Vect k) = VectAr Int Int [[Int]] Source |

data Cob2 Source

Instances

Monoidal Cob2 Source |
MCategory Cob2 Source |
Eq (Ob Cob2) Source |
Eq (Ar Cob2) Source |
Ord (Ob Cob2) Source |
Ord (Ar Cob2) Source |
Show (Ob Cob2) Source |
Show (Ar Cob2) Source |
data Ob Cob2 = O Int Source |

data Ar Cob2

- = Id Int
- | Unit
- | Mult
- | Counit
- | Comult
- | Par (Ar Cob2) (Ar Cob2)
- | Seq (Ar Cob2) (Ar Cob2)

Source

rewrite :: Ar Cob2 -> Ar Cob2 Source